unit Unit1;

//{$DEFINE MEMCHK}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, ExtCtrls,
  ComCtrls, ShellCtrls, FileCtrl, Buttons, Menus, AxCtrls
  {$IFDEF MEMCHK}
  ,MemCheck
  {$ENDIF}
  ,CADViewLib_TLB, CheckLst;

type
  TfmMain = class(TForm)
    mmMain: TMainMenu;
    mmiFile: TMenuItem;
    mmiOpen: TMenuItem;
    OpenDialog1: TOpenDialog;
    pnlMain: TPanel;
    BtnOpen: TSpeedButton;
    BtnPlus: TSpeedButton;
    BtnMinus: TSpeedButton;
    BtnReal: TSpeedButton;
    BtnPrint: TSpeedButton;
    BtnSave: TSpeedButton;
    btnLayers: TSpeedButton;
    BtnPrint1: TSpeedButton;
    btnFitToScreen: TSpeedButton;
    btnIsWithoutBorder: TSpeedButton;
    BtnPrev: TSpeedButton;
    mmiSave: TMenuItem;
    N1: TMenuItem;
    mmiClose: TMenuItem;
    N2: TMenuItem;
    mmiExit: TMenuItem;
    mmiView: TMenuItem;
    mmiZoomIn: TMenuItem;
    mmiZoomOut: TMenuItem;
    mmi1x1: TMenuItem;
    mmiPrevScale: TMenuItem;
    mmiAbout: TMenuItem;
    mmiPrint: TMenuItem;
    mmiIsWithoutBorder: TMenuItem;
    mmiPrintPreview: TMenuItem;
    btnSaveIni: TSpeedButton;
    mmOptions: TMenuItem;
    mmiShowToolBar: TMenuItem;
    mmiShowLayoutsBar: TMenuItem;
    N3: TMenuItem;
    mmiOptioons: TMenuItem;
    mmiLoadConfig: TMenuItem;
    mmiSaveConfig: TMenuItem;
    cbLayouts: TComboBox;
    sbStatus: TStatusBar;
    clbLayers: TCheckListBox;
    CADViewX: TCADViewX;
    procedure mmiOpenClick(Sender: TObject);
    procedure BtnPlusClick(Sender: TObject);
    procedure BtnMinusClick(Sender: TObject);
    procedure mmiExitClick(Sender: TObject);
    procedure mmiCloseClick(Sender: TObject);
    procedure btnFitToScreenClick(Sender: TObject);
    procedure BtnPrevClick(Sender: TObject);
    procedure BtnRealClick(Sender: TObject);
    procedure mmiAboutClick(Sender: TObject);
    procedure mmiIsWithoutBorderClick(Sender: TObject);
    procedure BtnPrintClick(Sender: TObject);
    procedure mmiPrintPreviewClick(Sender: TObject);
    procedure mmiPrintClick(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure cadViewXMouseUp(ASender: TObject; Button: TOleEnum; Shift,
      X, Y: Integer);
    procedure btnLayersClick(Sender: TObject);
    procedure cadViewXMouseMove(ASender: TObject; Shift, X, Y: Integer);
    procedure cadViewXProgress(ASender: TObject; State: TOleEnum;
      PercentDone: Byte; RedrawNow: WordBool; const Msg: WideString);
    procedure cadViewXAfterLoad(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mmiShowToolBarClick(Sender: TObject);
    procedure mmiShowLayoutsBarClick(Sender: TObject);
    procedure mmiOptioonsClick(Sender: TObject);
    procedure mmiLoadConfigClick(Sender: TObject);
    procedure mmiSaveConfigClick(Sender: TObject);
    procedure mmOptionsClick(Sender: TObject);
    procedure cbLayoutsCloseUp(Sender: TObject);
    procedure clbLayersClickCheck(Sender: TObject);
    procedure clbLayersKeyPress(Sender: TObject; var Key: Char);
    procedure clbLayersDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Private declarations }
    procedure SetControls;
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

{$R *.dfm}

procedure TfmMain.SetControls;
var
  I, J: Integer;
begin
  for I := 0 to pnlMain.ControlCount - 1 do
  begin
    if (pnlMain.Controls[I] is TSpeedButton)and(TSpeedButton(pnlMain.Controls[I]).Tag = 1) then
      TSpeedButton(pnlMain.Controls[I]).Enabled := cadViewX.IsVectGraphic;
  end;

  for I := 0 to mmMain.Items.Count - 1 do
  begin
    for J := 0 to mmMain.Items[I].Count - 1 do
      if mmMain.Items[I].Items[J].Tag = 1 then
        mmMain.Items[I].Items[J].Enabled := cadViewX.IsVectGraphic;
  end;

  if cadViewX.IsVectGraphic then
  begin
    cbLayouts.Items.Clear;
    for I := 0 to cadViewX.DXFImage.LayoutsCount - 1 do
      cbLayouts.Items.Add(string(cadViewX.DXFImage.Converter.Layouts[I].Name));
  end
  else
  begin
    cbLayouts.Items.Clear;
    cbLayouts.Text := '';
  end;
end;

procedure TfmMain.mmiOpenClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    cadViewX.LoadFile(WideString(OpenDialog1.FileName));
end;

procedure TfmMain.BtnPlusClick(Sender: TObject);
begin
  cadViewX.ScaleImage(False, 2, Width div 2, Height div 2);
end;

procedure TfmMain.BtnMinusClick(Sender: TObject);
begin
  cadViewX.ScaleImage(False, 0.5, Width div 2, Height div 2);
end;

procedure TfmMain.mmiExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfmMain.mmiCloseClick(Sender: TObject);
begin
  cadViewX.CloseFile;
  SetControls;
end;

procedure TfmMain.btnFitToScreenClick(Sender: TObject);
begin
  cadViewX.DoToolButtonClick(tbFitToWindow);
end;

procedure TfmMain.BtnPrevClick(Sender: TObject);
begin
  cadViewX.PrevScale;
end;

procedure TfmMain.BtnRealClick(Sender: TObject);
begin
  cadViewX.ScaleImage(True, 1.0, Width div 2, Height div 2);
end;

procedure TfmMain.mmiAboutClick(Sender: TObject);
begin
  cadViewX.ShowAbout;
end;

procedure TfmMain.mmiIsWithoutBorderClick(Sender: TObject);
begin
  cadViewX.IsWithoutBorder := not cadViewX.IsWithoutBorder;
end;

procedure TfmMain.BtnPrintClick(Sender: TObject);
begin
  cadViewX.DoToolButtonClick(tbPrint);
end;

procedure TfmMain.mmiPrintPreviewClick(Sender: TObject);
begin
  cadViewX.PaperOrientation := 1;
  cadViewX.DoToolButtonClick(tbPrintPreview);
end;

procedure TfmMain.mmiPrintClick(Sender: TObject);
begin
  cadViewX.PrintImage;
end;

procedure TfmMain.BtnSaveClick(Sender: TObject);
var
  vFileToSave: string;
begin
  vFileToSave := cadViewX.FileName;
  vFileToSave := ChangeFileExt(vFileToSave, '.bmp');
  cadViewX.SaveToFileEx(vFileToSave, True, True);
end;

procedure TfmMain.cadViewXMouseUp(ASender: TObject; Button: TOleEnum;
  Shift, X, Y: Integer);
var
  P: TPoint;
begin
  P := TControl(ASender).ClientToScreen(Point(X, Y));
  if Button = mbRight then
    cadViewX.Popup(P.X, P.Y);
end;

procedure TfmMain.btnLayersClick(Sender: TObject);
var
  S: WideString;
  I: Integer;
begin
  //cadViewX.ShowLayersDialog;
  if CADViewX.DXFImage <> nil then
  begin
    CADViewX.DXFImage.Converter.GetLayerNames(s, true, true);
    clbLayers.Items.Clear;
    clbLayers.Items.Text := S;
    for I := 0 to CADViewX.DXFImage.Converter.Counts[TOleEnum(csLayers)] - 1 do
      clbLayers.Checked[I] := CADViewX.DXFImage.Converter.Layers[I].Visible;
    clbLayers.Hide;
    clbLayers.Show;
  end;
end;

procedure TfmMain.cadViewXMouseMove(ASender: TObject; Shift, X,
  Y: Integer);
var
  vPt: tagFPoint;
begin
  vPt := cadViewX.CADCoords(X, Y);
  sbStatus.Panels[1].Text := Format('(%.3f; %.3f; %.3f)', [vPt.X, vPt.Y, 0.0]);
end;

procedure TfmMain.cadViewXProgress(ASender: TObject; State: TOleEnum;
  PercentDone: Byte; RedrawNow: WordBool; const Msg: WideString);
begin
  sbStatus.Panels[0].Text := string(Msg) + ' ' + IntToStr(PercentDone) + '% complete';
end;

procedure TfmMain.cadViewXAfterLoad(Sender: TObject);
var
  I: Integer;
begin
  sbStatus.Panels[0].Text := cadViewX.FileName;
  SetControls;
  if CADViewX.IsVectGraphic then
    cbLayouts.ItemIndex := CADViewX.DXFImage.Converter.DefaultLayoutIndex;
  cadViewX.DoToolButtonClick(tbFitToWindow);
  Self.FocusControl(cadViewX);
end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
  cadViewX.LayoutsBarVisible := False;
  cadViewX.ToolBarVisible := False;
  cadViewX.Align := alClient;
  mmiShowToolBar.Checked := cadViewX.ToolBarVisible;
  mmiShowLayoutsBar.Checked := cadViewX.LayoutsBarVisible;
  clbLayers.DragKind := dkDock;
  clbLayers.DragMode := dmAutomatic;
  clbLayers.ManualDock(nil);
  TCustomDockForm(clbLayers.Parent).Caption := 'Layers';
  clbLayers.Hide;
end;

procedure TfmMain.mmiShowToolBarClick(Sender: TObject);
begin
  cadViewX.ToolBarVisible := mmiShowToolBar.Checked;
end;

procedure TfmMain.mmiShowLayoutsBarClick(Sender: TObject);
begin
  cadViewX.LayoutsBarVisible := mmiShowLayoutsBar.Checked;
end;

procedure TfmMain.mmiOptioonsClick(Sender: TObject);
begin
  cadViewX.DoToolButtonClick(tbOptions);
end;

procedure TfmMain.mmiLoadConfigClick(Sender: TObject);
var
  vIniFile: string;
begin
  vIniFile := ExtractFilePath(Application.ExeName) + 'Demo.ini';
  cadViewX.LoadFromIni(WideString(vIniFile));
end;

procedure TfmMain.mmiSaveConfigClick(Sender: TObject);
var
  vIniFile: string;
begin
  vIniFile := ExtractFilePath(Application.ExeName) + 'Demo.ini';
  cadViewX.SaveToIni(WideString(vIniFile));
end;

procedure TfmMain.mmOptionsClick(Sender: TObject);
begin
  mmiShowToolBar.Checked := cadViewX.ToolBarVisible;
  mmiShowLayoutsBar.Checked := cadViewX.LayoutsBarVisible;
end;

procedure TfmMain.cbLayoutsCloseUp(Sender: TObject);
begin
  if cadViewX.IsVectGraphic then
  begin
    CADViewX.DXFImage.CurrentLayout := CADViewX.DXFImage.Converter.Layouts[cbLayouts.ItemIndex];
    cadViewX.DoToolButtonClick(tbFitToWindow);
    Self.FocusControl(cadViewX);
  end;
end;

procedure TfmMain.clbLayersClickCheck(Sender: TObject);
begin
  if clbLayers.ItemIndex <> -1 then
  begin
    CADViewX.DXFImage.Converter.Layers[clbLayers.ItemIndex].Visible := clbLayers.Checked[clbLayers.ItemIndex];
    cadViewX.PictureRepaint;
  end;
end;

procedure TfmMain.clbLayersKeyPress(Sender: TObject; var Key: Char);
begin
  clbLayersClickCheck(Sender);
end;

procedure TfmMain.clbLayersDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  if Index < clbLayers.Items.Count then
    with clbLayers.Canvas do
    begin
      Pen.Color := clWindow;
      with Rect do Rectangle(Left, Top, Right, Bottom);
      Pen.Color := clWindowFrame;
      Brush.Color := CADViewX.DXFImage.Converter.Layers[Index].PenColor;
      with Rect do Rectangle(Left, Top + 2, Left + 16, Bottom - 2);
      if State = [] then
      begin
        Brush.Color := clWindow;
        Pen.Color := clWindowText;
      end
      else
      begin
        Brush.Color := clHighlight;
        Pen.Color := clHighlightText;
      end;
      with Rect do TextOut(Left + 24, Top, clbLayers.Items[Index]);
      Brush.Color := clWindow;
      Pen.Color := clWindowText;
    end;
end;

initialization

  {$IFDEF MEMCHK}
  MemChk
  {$ENDIF}

end.
